Index: loader/source/update-light.c
===================================================================
--- loader/source/update-light.c	(nonexistent)
+++ loader/source/update-light.c	(working copy)
@@ -0,0 +1,787 @@
+/*
+
+Nintendont (Loader) - Playing Gamecubes in Wii mode on a Wii U
+
+Copyright (C) 2014  JoostinOnline
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation version 2.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+*/
+
+#include <gccore.h>
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <network.h>
+
+#include <zlib.h>
+#include <ogc/lwp_watchdog.h>
+
+#include "exi.h"
+#include "FPad.h"
+#include "font.h"
+#include "global.h"
+#include "http.h"
+#include "menu.h"
+#include "update.h"
+#include "ff_utf8.h"
+#include "unzip/miniunz.h"
+#include "unzip/ioapi.h"
+#include "../../common/include/NintendontVersion.h"
+extern void changeToDefaultDrive();
+extern char launch_dir[MAXPATHLEN];
+extern int selected;
+typedef struct {
+	const char url[96];
+	const char text[30];
+	const char filename[30];
+	const u32 max_size;
+} downloads_t;
+
+typedef enum {
+	DOWNLOAD_THEMES,
+	DOWNLOAD_CLASSIC,
+	DOWNLOAD_CLASSICWII,
+	DOWNLOAD_DISCS,
+	DOWNLOAD_GCNS,
+	DOWNLOAD_MMBLUE,
+	DOWNLOAD_MMCLASSIC,
+	DOWNLOAD_MMDARK1,
+	DOWNLOAD_MMDARK2,
+	DOWNLOAD_ORANGE,
+	DOWNLOAD_PURPLE,
+	DOWNLOAD_SMASH,
+	DOWNLOAD_BARS,
+	DOWNLOAD_AAA,
+	DOWNLOAD_BBB,
+	DOWNLOAD_CCC	
+} DOWNLOADS;
+
+static const downloads_t Downloads[] = {
+	{"http://send0r.de/Nintendont/MasterMod/back00.zip", "Downloading Theme", "back00.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back01.zip", "Downloading Theme", "back01.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back02.zip", "Downloading Theme", "back02.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back03.zip", "Downloading Theme", "back03.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back04.zip", "Downloading Theme", "back04.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back05.zip", "Downloading Theme", "back05.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/back06.zip", "Downloading Theme", "back06.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back07.zip", "Downloading Theme", "back07.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back08.zip", "Downloading Theme", "back08.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/back09.zip", "Downloading Theme", "back09.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back10.zip", "Downloading Theme", "back10.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back11.zip", "Downloading Theme", "back11.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back12.zip", "Downloading Theme", "back12.zip", 0x80000}, // 512KB	
+	{"http://send0r.de/Nintendont/MasterMod/back13.zip", "Downloading Theme", "back13.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back14.zip", "Downloading Theme", "back14.zip", 0x80000}, // 512KB
+	{"http://send0r.de/Nintendont/MasterMod/back15.zip", "Downloading Theme", "back15.zip", 0x80000}, // 512KB		
+};
+
+static int UnzipThemes(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_THEMES].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_THEMES].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_THEMES].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipClassic(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CLASSIC].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_CLASSIC].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_CLASSIC].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipClassicwii(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CLASSICWII].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_CLASSICWII].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_CLASSICWII].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipDiscs(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_DISCS].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_DISCS].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_DISCS].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipGcns(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_GCNS].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_GCNS].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_GCNS].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipMmblue(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_MMBLUE].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_MMBLUE].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_MMBLUE].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipMmclassic(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_MMCLASSIC].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_MMCLASSIC].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_MMCLASSIC].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipMmdark1(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_MMDARK1].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_MMDARK1].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_MMDARK1].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipMmdark2(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_MMDARK2].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_MMDARK2].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_MMDARK2].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipOrange(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_ORANGE].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_ORANGE].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_ORANGE].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipPurple(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_PURPLE].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_PURPLE].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_PURPLE].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipSmash(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_SMASH].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_SMASH].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_SMASH].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipBars(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_BARS].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_BARS].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_BARS].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipAaa(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_AAA].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_AAA].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_AAA].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipBbb(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_BBB].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_BBB].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_BBB].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipCcc(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CCC].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_CCC].filename);
+	
+	changeToDefaultDrive();
+	f_chdir_char("/apps/Nintendont");
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_CCC].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static s32 Download(DOWNLOADS download_number)  {
+	ClearScreen();
+	
+	int line = 1;
+	int ret;
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	bool dir_argument_exists = strlen(launch_dir);
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "/apps/Nintendont/", Downloads[download_number].filename);
+	if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+	if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
+		if (ret) break;
+		if (i == 10) {
+			gprintf("Error making http request\r\n");
+			ret = -1;
+			goto end;
+		}
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+
+	UpdateScreen();
+	line++;
+	if (!dir_argument_exists) {
+		gprintf("Creating new directory\r\n");
+		f_mkdir_char("/apps/Nintendont");
+	}
+		if (download_number == DOWNLOAD_THEMES) {ret = UnzipThemes(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_CLASSIC) {ret = UnzipClassic(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_CLASSICWII) {ret = UnzipClassicwii(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_DISCS) {ret = UnzipDiscs(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_GCNS) {ret = UnzipGcns(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_MMBLUE) {ret = UnzipMmblue(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_MMCLASSIC) {ret = UnzipMmclassic(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_MMDARK1) {ret = UnzipMmdark1(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_MMDARK2) {ret = UnzipMmdark2(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_ORANGE) {ret = UnzipOrange(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_PURPLE) {ret = UnzipPurple(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_SMASH) {ret = UnzipSmash(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_BARS) {ret = UnzipBars(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_AAA) {ret = UnzipAaa(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_BBB) {ret = UnzipBbb(outbuf, filesize);}
+		else if (download_number == DOWNLOAD_CCC) {ret = UnzipCcc(outbuf, filesize);}
+else
+	{
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+			gprintf("File Error\r\n");
+			ret = -3;
+			goto end;
+		} else {
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+	}
+end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Update Error: %i", ret);
+			f_rename_char( "./NinBack.old", "./NinBack.png");
+			f_rename_char( "./NinBlack.old", "./NinBlack.png");
+			f_rename_char( "./NinLegacy.old", "./NinLegacy.png");
+			UpdateScreen();
+			if (outbuf != NULL) free(outbuf);
+			net_deinit();
+			sleep(2);
+			return ret;
+		}
+	else {
+	if (which_bg == BG_NONE)
+	{PrintFormat(37, 0x80000000, MENU_POS_X, MENU_POS_Y + 20*(line+15), "Applying The New Theme Now");}
+	else if (which_bg == BG_LEGACY)
+	{PrintFormat(37, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+15), "Applying The New Theme Now");}}
+	UpdateScreen();
+	if (outbuf != NULL) free(outbuf);
+	net_deinit();
+	sleep(2);
+	BackTheme();
+	return ret;
+}
+
+void UpdateThemes(void) {
+	selected = 0;
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+		ClearScreen();
+		BackTheme();
+		if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Light Themes Download Menu");	
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Orchid Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Aqua Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Sunshine Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download Shroom Theme");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download Triforce Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download GC Logo Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Rays Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Download Carbonix Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Download Arcadia Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Download Zelda OoT Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Download Double-Dash Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Download Bright Sky Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Download Wii Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*17, "Download Kirby Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*18, "Download Controller Theme");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*19, "Download Luigi Theme");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Light Themes Download Menu");	
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");	
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Orchid Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Aqua Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Sunshine Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download Shroom Theme");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download Triforce Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download GC Logo Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Rays Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Download Carbonix Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Download Arcadia Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Download Zelda OoT Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Download Double-Dash Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Download Bright Sky Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Download Wii Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*17, "Download Kirby Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*18, "Download Controller Theme");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*19, "Download Luigi Theme");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+		//////////
+		if (f_chdir_char("/apps/Nintendont/Preview/light") == FR_OK){
+		Preview();}
+		//////////
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+			if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+			if (FPAD_OK(1)) {
+			f_chdir_char("/apps/Nintendont");
+			if (selected <= (DOWNLOAD_CCC))
+			{
+			f_rename_char( "./NinBack.png", "./NinBack.old");
+			f_rename_char( "./NinBlack.png", "./NinBlack.old");
+			f_rename_char( "./NinLegacy.png", "./NinLegacy.old");
+			Download(selected);
+			f_unlink_char( "./NinBack.old" );
+			f_unlink_char( "./NinBlack.old" );
+			f_unlink_char( "./NinLegacy.old" );
+			GRRLIB_FreeTexture(background);
+			which_bg = BG_NONE;
+			background = GRRLIB_LoadTextureFromFile("NinBack.png");	
+			if (background == NULL)
+			background = GRRLIB_LoadTexturePNG(background_png);
+			FadeIt();
+			}
+			else
+				break;
+		}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 15) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 15;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}
+		if (FPAD_Cancel(1)) {
+			break;
+		}
+	}
+	ClearScreen();
+	UpdateNintendont();
+}
